<?php 
/*
# ------------------------------------------------------------------------
# JA Content Scroll module for Joomla 1.5
# ------------------------------------------------------------------------
# Copyright (C) 2004-2010 JoomlArt.com. All Rights Reserved.
# @license - PHP files are GNU/GPL V2. CSS / JS are Copyrighted Commercial,
# bound by Proprietary License of JoomlArt. For details on licensing, 
# Please Read Terms of Use at http://www.joomlart.com/terms_of_use.html.
# Author: JoomlArt.com
# Websites:  http://www.joomlart.com -  http://www.joomlancers.com
# Redistribution, Modification or Re-licensing of this file in part of full, 
# is bound by the License applied. 
# ------------------------------------------------------------------------
*/ 


defined( '_JEXEC' ) or die( 'Restricted access' );

class JAContentSlideHelper{
	
	function getInstance(){
		static $instance = null;
		if( !$instance ){
			$instance = new JAContentSlideHelper();
		}
		return $instance;
	}
	/**
	 * get list of articles base on owner's configuration
	 */
	function getList( $catid, $params ){
		$rows = array();

		// check cache was endable ?
		if ( $params->get('enable_cache', 1) ) {
			$cache = JFactory::getCache();
			$cache->setCaching( true );
			$cache->setLifeTime( $params->get( 'cache_time', 30 ) * 60 );	
			$rows = $cache->get( array( $this , '_getListArticles' ), array($catid, $params) ); 
		} else {
			$rows = $this->_getListArticles( $catid, $params );
		}					

		return $rows;
	}
	/**
	 * processing on render article information
	 */
	function onRendering( &$item, &$params, $numChar, $showimages, $iwidth, $iheight, $autoresize ){
		global $mainframe;
		$item->text 	 = $item->introtext;
		$mainframe->triggerEvent( 'onPrepareContent', array( &$item, &$params, 0 ) , true );
		$item->introtext = $item->text;
		$item->imageArticle = $this->replaceImage ( $item, $numChar, $showimages, $iwidth, $iheight, $autoresize );////////////////
		
		$item->linkArticle   = JRoute::_(ContentHelperRoute::getArticleRoute( $item-> slug,$item->catslug, $item->sectionid) );	
		
	}
	/**
	 * get list of articles from multiple categories.
	 */
	function _getListArticles( $catid, $params ){
		global $mainframe; 
	 	$db	    = JFactory::getDBO();
		
		$my = JFactory::getUser();

		$aid	= $my->get( 'aid', 0 );
		$date = JFactory::getDate();
		$now  = $date->toMySQL();
		$query 	= 	'SELECT a.*,cc.description as catdesc, cc.title as cattitle,s.description as secdesc, s.title as sectitle,' .
					' CASE WHEN CHAR_LENGTH(a.alias) THEN CONCAT_WS(":", a.id, a.alias) ELSE a.id END as slug,'.
					' CASE WHEN CHAR_LENGTH(cc.alias) THEN CONCAT_WS(":",cc.id,cc.alias) ELSE cc.id END as catslug,'.
					' CASE WHEN CHAR_LENGTH(s.alias) THEN CONCAT_WS(":", s.id, s.alias) ELSE s.id END as secslug'
					. "\n FROM #__content AS a".
					' INNER JOIN #__categories AS cc ON cc.id = a.catid' .
					' INNER JOIN #__sections AS s ON s.id = a.sectionid'
					. "\n WHERE a.state = 1"
					. "\n AND ( a.publish_up = " . $db->Quote( $db->getNullDate() ) . " OR a.publish_up <= " . $db->Quote( $now  ) . " )"
					. "\n AND ( a.publish_down = " . $db->Quote( $db->getNullDate() ) . " OR a.publish_down >= " . $db->Quote( $now  ) . " )"
					. ( ( !$mainframe->getCfg( 'shownoauth' ) ) ? "\n AND a.access <= " . (int) $aid : '' )
					;
		if( $catid ) {
			$query .= ' AND a.catid IN ('.$catid.') ';
		}
	
		// order by 
		$orderBy = "a." . $params->get('sort_order_field', 'created') . ' ' . $params->get('sort_order', 'DESC');
		$query .= ' ORDER BY ' . $orderBy;
		$query .=  ' LIMIT ' . $params->get('maxitems', 10);
		
		$db->setQuery($query);
		
		return $db->loadObjectlist();
	}
	/**
	 * render image.
	 */
	function replaceImage( &$row, $maxchars, $showimage, $width = 0, $height = 0 ,$autoresize) {
		//global $database, $_MAMBOTS, $current_charset;

		// expression to search for
			//$regex = "/\<img.*\/\>/";
		$regex = "/\<img\s*src\s*=\s*\"([^\"]*)\"[^\>]*\>/";
		preg_match ($regex, $row->introtext, $matches);
		$images = (count($matches)) ? $matches : array();
		$image = ($showimage && count($images))? $this->processImage ( $images, $width, $height ,$autoresize):"";
		if ($autoresize) {
			if ($image) {				
				$image = "<img src=\"$image\" alt=\"{$row->title}\" />";
			}
			$regex1 = "/\<img.*\/\>/";
			$row->introtext = trim($row->introtext);
			$row->introtext = preg_replace( $regex1, '', $row->introtext );
		} else {
			$regex = "/\<img.*\/\>/";
			preg_match ($regex, $row->introtext, $matches);
			$row->introtext = trim($row->introtext);
			$row->introtext = preg_replace ($regex, '', $row->introtext);

			$image = $showimage && count($matches)?$matches[0]:"";
			if (count($images)) {
				$image = "<img src=\"".$images[1]."\" alt=\"{$row->title}\" width=\"$width\"  heigh=\"$height\" />";
			}
		}

		$row->introtext1 = strip_tags($row->introtext);
		if ($maxchars && strlen ($row->introtext) > $maxchars) {
			$row->introtext1 = substr ($row->introtext1, 0, $maxchars) . "...";
		}
		// clean up globals
		return $image;
	}
	
	function processImage ( &$image, $width, $height ) {
		/* for 1.5 - don't need to use image parameter */
		if(!count($image)) return;
			$img = $image[1] ;
			$imagesurl = (file_exists(JPATH_SITE .'/'.$img)) ? $this->jaResize($img,$width,$height) :  $img ;
			return $imagesurl;
		/* End 1.5 */
	}

	function jaResize($image,$max_width,$max_height){
		$path = JPATH_SITE;
			$sizeThumb = getimagesize(JPATH_SITE.'/'.$image);
			$width = $sizeThumb[0];
			$height = $sizeThumb[1];
			
			$x_ratio = $max_width / $width;
			$y_ratio = $max_height / $height;
			
			if (($width <= $max_width) && ($height <= $max_height) ) {
				$tn_width = $width;
				$tn_height = $height;
			} else if (($x_ratio * $height) < $max_height) {
				$tn_height = ceil($x_ratio * $height);
				$tn_width = $max_width;
			} else {
				$tn_width = ceil($y_ratio * $width);
				$tn_height = $max_height;
			}
			if(file_exists($path.'/images/resized/'.$image)){
				$smallImg = getimagesize(JPATH_SITE.'/images/resized/'.$image);
				if ($smallImg[0] <= $smallImg[1] && $smallImg[1] != $max_height) {
				} else if ($smallImg[1] <= $smallImg[0] && $smallImg[0] != $max_width) {
				} else {
						return "images/resized/".$image;
				}
			}
			if(!file_exists($path.'/images/resized/')) mkdir($path.'/images/resized/',0755);
			$folders = explode('/',$image);
			$tmppath = $path.'/images/resized/';
			for($i=0;$i < count($folders)-1; $i++){
				if(!file_exists($tmppath.$folders[$i])) mkdir($tmppath.$folders[$i],0755);
				$tmppath = $tmppath.$folders[$i].'/';
			}
			$resized = $path.'/images/resized/'.$image;
			// read image
			$ext = strtolower(substr(strrchr($image, '.'), 1)); // get the file extension
			switch ($ext) { 
				case 'jpg':     // jpg
					$src = imagecreatefromjpeg(JPATH_SITE.'/'.$image);
					break;
				case 'png':     // png
					$src = imagecreatefrompng(JPATH_SITE.'/'.$image);
					break;
				case 'gif':     // gif
					$src = imagecreatefromgif(JPATH_SITE.'/'.$image);
					break;
				default:
			}
			
			$dst = imagecreatetruecolor($tn_width,$tn_height);
			if (function_exists('imageantialias')) imageantialias ($dst, true);
			imagecopyresampled ($dst, $src, 0, 0, 0, 0, $tn_width, $tn_height, $width, $height);
			imagejpeg($dst, $resized, 90); // write the thumbnail to cache as well...
			return "images/resized/".$image;		
	}
		
}
?>
